#include <stdio.h>

typedef struct format {
	char karakter;
	int broj;
} FORMAT;

void procitaj_datoteku(char tekst[], int *n) {
	FILE *datoteka;
	char znak;
	datoteka = fopen("ulaz.txt", "r");
	if (datoteka == NULL) {
		printf("Doslo je do greske!\n");
		return;
	}
	while((znak = fgetc(datoteka)) != EOF) {
		tekst[*n] = znak;
		*n = *n + 1;
	}
	fclose(datoteka);
}

int broj_pojavljivanja(char tekst[], int n, char znak) {
	int i;
	int brojac = 0;
	for (i=0; i<n; i++) {
		if (znak == tekst[i]) {
			brojac++;
		}
	}
	return brojac;
}

int postoji(FORMAT format[], int broj, char znak) {
	// 1 - ako znak postoji, 0 - ako znak ne postoji
	int i;
	for (i=0; i<broj; i++) {
		if (format[i].karakter == znak) {
			return 1;
		} 
	}
	return 0;
}

void generisi_upis(FORMAT format[], int *broj, char tekst[], int n) {
	int i;
	int brojac;
	FORMAT f;
	int obradjen;
	for (i=0; i<n; i++) {
		brojac = broj_pojavljivanja(tekst, n, tekst[i]);
		obradjen = postoji(format, *broj, tekst[i]);
		if (obradjen == 0) {
			// Karakter nije obradjen
			f.karakter = tekst[i];
			f.broj = brojac;
			format[*broj] = f;
			*broj = *broj + 1;
		}
	}
}

void upisi_u_datoteku(FORMAT format[], int broj) {
	FILE *datoteka;
	int i;
	datoteka = fopen("izlaz.txt", "w");
	if (datoteka == NULL) {
		printf("Greska prilikom upisa!\n");
		return;
	}
	for (i=0; i<broj; i++) {
		if (format[i].broj >= 2) {
			// Treba izvrsiti upis u formatu 'karakter -> broj_pojavljivanja'
			fprintf(datoteka, "%c -> %d\n", format[i].karakter, format[i].broj);
		}
	}
	fclose(datoteka);
}

int main(void) {
	char tekst[100];
	int n = 0; // Oznacava broj elemenata u nizu tekst
	FORMAT format[100];
	int broj = 0; // Oznacava broj elemenata u nizu format

	// Korak 1
	procitaj_datoteku(tekst,&n);

	// Korak 2
	generisi_upis(format, &broj, tekst, n);

	// Korak 3
	upisi_u_datoteku(format, broj);

	return 0;
}